:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3184,_3178/_3180,_3188):-(retract(dynamicVersion(_3184,_3178/_3180,_3202))->true;true),asserta(dynamicVersion(_3184,_3178/_3180,_3188)).
prim_assertFact('Dynamic.Dynamic'(_3296),'Prelude.()'):-retract(dynamicTime(_3306)),_3320 is _3306+1,assertz(dynamicTime(_3320)),_3296=..[_3334,_3340,_3346,_3352|_3354],_3382=..[_3334,_3320,0|_3354],assertz(user:_3382),logDynamicEvent(_3340,assertz,_3382).
prim_retractFact('Dynamic.Dynamic'(_3484),_3490):-_3484=..[_3494,_3500,_3506,_3512|_3514],_3542=..[_3494,_3530,_3536|_3514],reloadNewestDynamicVersionOf(_3494),retract(dynamicTime(_3552)),_3566 is _3552+1,assertz(dynamicTime(_3566)),call(user:_3542),isInTimeInterval(_3552,_3530,_3536),!,_3616=..[_3494,_3530,_3552|_3514],retract(user:_3542),!,logDynamicEvent(_3500,retract,_3542),assertz(user:_3616),_3490='Prelude.True'.
prim_retractFact(_3782,'Prelude.False').
prim_getDynamicKnowledge(_3818):-reloadNewestDynamicVersions,dynamicTime(_3822),term2partcall('Dynamic.isKnownAtTime'(_3822),1,_3818),(compileWithSharing(function)->makeShare(_3818,_3844);_3844=_3818).
prim_isKnownAtTime(_3922,'Dynamic.Dynamic'(_3918),'Prelude.True'):-_3918=..[_3930,_3936,_3942,_3948|_3950],_3978=..[_3930,_3966,_3972|_3950],call(user:_3978),isInTimeInterval(_3922,_3966,_3972).
isInTimeInterval(_4070,_4072,_4074):-_4070>=_4072,(_4074=0->true;_4070=<_4074).
logDynamicEvent('Dynamic.Temporary',_4166,_4168):-!.
logDynamicEvent('Dynamic.Persistent',_4224,_4226):-_4226=..[_4230,_4236,_4242|_4244],_4272=..[_4230,0,0|_4244],_4290=..[_4224,_4272],user:dynamicPredInfo(_4230/_4298,_4304),logDynamic(_4290,_4304).
logDynamic(_4394,_4396):-dir2tmplockfile(_4396,_4402),lockWithFileIfNotInTransaction(_4402),executeWithFinalize((dir2logfile(_4396,_4412),open(_4412,append,_4420),writeq(_4420,_4394),put_code(_4420,46),nl(_4420),flush_output(_4420),close(_4420),addChangePid(_4396)),unlockWithFileIfNotInTransaction(_4402)).
executeWithFinalize(_4558,_4560):-on_exception(_4568,_4558,(call(_4560),printError(_4568),!,fail)),!,call(_4560).
executeWithFinalize(_4656,_4658):-call(_4658),!,fail.
prim_startTransaction(_4720):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4782,initTransaction(_4720),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4782),fail)),!.
initTransaction(_4864):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4868)),_4864 is _4868+1,assertz(dynamicTime(_4864)),logAllDynamicPreds(startTransaction(_4864)).
prim_commitTransaction(_4968,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4968)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5052):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5060),map1partialM(prim_dynamic:addChangePid(0),_5060),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5166):-findall(_5170,isDynamicDir(_5170),_5178),sort(_5178,_5166).
isDynamicDir(_5228):-user:dynamicPredInfo(_5232,_5228),\+_5228=''.
logAllDynamicPreds(_5294):-getDynamicDirs(_5298),map1partialM(prim_dynamic:logDynamic(_5294),_5298).
initializeDynamic:-user:dynamicPredInfo(_5358/_5360,_5366),initializeDynamic(_5366,_5358/_5360),fail.
initializeDynamic.
initializeDynamic('',_5436/_5438):-!,retractAllFacts(_5436/_5438).
initializeDynamic(_5512,_5506/_5508):-existsDirectory(_5512),!,checkDynSpec(_5512,_5506/_5508),setDynamicVersion(_5512,_5506/_5508,0),!.
initializeDynamic(_5614,_5616):-existsFile(_5614),!,appendAtom('ERROR: Directory "',_5614,_5628),appendAtom(_5628,'" for dynamic entries cannot be created!',_5636),writeErr(_5636),nlErr,!,fail.
initializeDynamic(_5734,_5728/_5730):-upDirectory(_5734,_5742),(existsDirectory(_5742)->createDynamicDir(_5734,_5728/_5730),setDynamicVersion(_5734,_5728/_5730,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5734),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5920,_5922):-atom_codes(_5920,_5928),append(_5938,[47|_5934],_5928),\+member(47,_5934),!,atom_codes(_5922,_5938).
upDirectory(_6028,'.').
checkDynSpec(_6070,_6064/_6066):-dir2specfile(_6070,_6078),existsFile(_6078),readPrologTermFile(_6078,_6088),dynamicSpec(_6064/_6066,_6088),!.
checkDynSpec(_6170,_6172):-appendAtom('ERROR: Directory "',_6170,_6180),appendAtom(_6180,'" contains no matching dynamic entries!',_6188),writeErr(_6188),nlErr,!,fail.
replayLogFile(_6274,_6268/_6270):-dir2tmplockfile(_6274,_6282),lockWithFileIfNotInTransaction(_6282),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6274,_6268/_6270),unlockWithFileIfNotInTransaction(_6282)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6390,_6384/_6386):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6390),writeErr('\'...'),nlErr;true),getRunTime(_6444),ensurePakcsVersion(_6390),dir2dbfile(_6390,_6454),dir2pofile(_6390,_6460),consultPrologorPOFile(_6454,_6460),dir2logfile(_6390,_6472),open(_6472,read,_6480),(atEndOfStream(_6480)->close(_6480);assert(replayStatus(unchanged)),repeat,on_exception(_6510,readAndReplay(_6480),((printError(_6510)->true;true),writeErr('ERROR during reading of '),writeErr(_6472),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6480),retract(replayStatus(_6574)),writeNewDatabaseIfChanged(_6384/_6386,_6390,_6574)),updateDynFactsIfNecessary(_6390,_6384/_6386),readDynamicVersion(_6390,_6646),setDynamicVersion(_6390,_6384/_6386,_6646),writeChangePids(_6390,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6680),_6690 is _6680-_6444,writeErr(_6690),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6872):-readPAKCSVersion(_6872,_6878),_6878=pakcsVersion(_6882,_6884),prologMajor(_6894),\+_6894=_6884,dir2pofile(_6872,_6910),(existsFile(_6910)->deleteFile(_6910);true),writePAKCSVersion(_6872),!.
ensurePakcsVersion(_7014).
isCurrentPakcsVersion(_7040):-readPAKCSVersion(_7040,_7046),compilerVersion(_7050),!,(_7046=compilerVersion(_7050)->writePAKCSVersion(_7040);_7046=pakcsVersion(_7050,_7076)).
readPAKCSVersion(_7144,_7146):-dir2pakcsversionfile(_7144,_7152),existsFile(_7152),readPrologTermFile(_7152,_7146).
writePAKCSVersion(_7220):-dir2pakcsversionfile(_7220,_7226),compilerVersion(_7230),prologMajor(_7234),writePrologTermFile(_7226,pakcsVersion(_7230,_7234)).
updateDynFactsIfNecessary(_7302,_7304):-isCurrentPakcsVersion(_7302),!.
updateDynFactsIfNecessary(_7366,_7360/_7362):-compilerVersion(_7372),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7366),writeErr('\' to compiler version '),writeErr(_7372),writeErr(...),nlErr;true),updateDynFacts(_7360/_7362),writeNewDatabaseIfChanged(_7360/_7362,_7366,changed),writePAKCSVersion(_7366).
updateDynFactsIfNecessary(_7538,_7540).
updateDynFacts(_7574/_7576):-functor(_7584,_7574,_7576),functor(_7592,_7574,_7576),retract(user:_7584),arg(1,_7584,_7614),arg(1,_7592,_7614),arg(2,_7584,_7630),arg(2,_7592,_7630),translateDynFactArgs(3,_7576,_7584,_7592),asserta(user:_7592),fail.
updateDynFacts(_7750).
translateDynFactArgs(_7776,_7778,_7780,_7782):-_7776>_7778,!.
translateDynFactArgs(_7856,_7858,_7860,_7862):-arg(_7856,_7860,_7870),translateDynFactArg(_7870,_7876),arg(_7856,_7862,_7876),_7894 is _7856+1,translateDynFactArgs(_7894,_7858,_7860,_7862).
translateDynFactArg(_7992,_7992):-var(_7992),!.
translateDynFactArg(_8050,_8050):-number(_8050),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8588,_8590):-atomic(_8588),atom_codes(_8588,[40|_8600]),!,appendAtom('Prelude.',_8588,_8590).
translateDynFactArg(_8678,_8680):-atom(_8678),atom_codes(_8678,[39|_8690]),!,(_8690=[_8700]->char_int(_8680,_8700);_8690=[78,85,76]->char_int(_8680,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8842,_8842):-atomic(_8842),!.
translateDynFactArg(_8900,_8902):-functor(_8900,_8908,_8910),translateDynFactArg(_8908,_8916),functor(_8902,_8916,_8910),translateDynFactArgs(1,_8910,_8900,_8902).
writeNewDatabaseIfChanged(_8998/_9000,_9006,changed):-!,dir2dbfile(_9006,_9014),dir2pofile(_9006,_9020),dir2logfile(_9006,_9026),appendAtom(_9014,'.bak',_9034),tell(_9034),writeq((:-dynamic _8998/_9000)),put_code(46),nl,listing(user:_8998/_9000),told,try_save_predicates(_8998/_9000,_9020),renameFile(_9034,_9014),appendAtom(_9026,'.bak',_9102),renameFile(_9026,_9102),appendAtom('touch ',_9026,_9116),shellCmd(_9116),readDynamicVersion(_9006,_9126),_9136 is _9126+1,writeDynamicVersion(_9006,_9136),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9346/_9348,_9354,_9356):-dir2logfile(_9354,_9362),appendAtom(_9362,'.bak',_9370),renameFile(_9362,_9370),appendAtom('touch ',_9362,_9384),shellCmd(_9384).
readAndReplay(_9466):-atEndOfStream(_9466),!.
readAndReplay(_9514):-read(_9514,_9520),replayEvent(_9514,_9520).
replayEvent(_9570,end_of_file):-!.
replayEvent(_9622,startTransaction(_9618)):-readAndReplayTransaction(_9622,_9618,[]),!,fail.
replayEvent(_9690,_9692):-retract(replayStatus(_9696)),assert(replayStatus(changed)),call(user:_9692),!,fail.
readAndReplayTransaction(_9788,_9790,_9792):-atEndOfStream(_9788),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9790),nlErr;true).
readAndReplayTransaction(_9900,_9902,_9904):-read(_9900,_9910),(_9910=commitTransaction(_9902)->callRevList(_9904);_9910=abortTransaction->true;readAndReplayTransaction(_9900,_9902,[_9910|_9904])),!.
callRevList([]).
callRevList([_10060|_10062]):-callRevList(_10062),retract(replayStatus(_10074)),assert(replayStatus(changed)),call(user:_10060).
startTransaction(_10152).
commitTransaction(_10178).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10216),map1M(prim_dynamic:lockDynamicDir,_10216).
lockDynamicDir(_10262):-dir2lockfile(_10262,_10268),lockWithFile(_10268).
lockWithFileIfNotInTransaction(_10316):-insideTransaction->true;lockWithFile(_10316).
lockWithFile(_10370):-appendAtom('lockfile-create --lock-name ',_10370,_10378),(existsFile(_10370),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10370),writeErr('\'...'),nlErr;true),shellCmd(_10378),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10496),map1M(prim_dynamic:unlockDynamicDir,_10496).
unlockDynamicDir(_10542):-dir2lockfile(_10542,_10548),unlockWithFile(_10548).
unlockWithFileIfNotInTransaction(_10596):-insideTransaction->true;unlockWithFile(_10596).
unlockWithFile(_10650):-existsFile(_10650),!,appendAtom('lockfile-remove --lock-name ',_10650,_10662),shellCmd(_10662).
unlockWithFile(_10722).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10748/_10750,_10756),dynamicVersion(_10756,_10748/_10750,_10776),reloadNewestDynamicVersion(_10756,_10748/_10750,_10776),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10848):-dynamicVersion(_10858,_10848/_10854,_10862),!,reloadNewestDynamicVersion(_10858,_10848/_10854,_10862).
reloadNewestDynamicVersionOf(_10926).
reloadNewestDynamicVersion(_10958,_10952/_10954,0):-!,retractAllFacts(_10952/_10954),replayLogFile(_10958,_10952/_10954),!.
reloadNewestDynamicVersion(_11062,_11056/_11058,_11066):-readDynamicVersion(_11062,_11072),\+_11066=_11072,!,retractAllFacts(_11056/_11058),replayLogFile(_11062,_11056/_11058),!.
reloadNewestDynamicVersion(_11188,_11190,_11192):-readChangePids(_11188,_11198),currentPID(_11202),(_11198=[];_11198=[_11202]),!.
reloadNewestDynamicVersion(_11304,_11298/_11300,_11308):-retractAllFacts(_11298/_11300),replayLogFile(_11304,_11298/_11300).
createDynamicDir(_11396,_11390/_11392):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11396),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11396,_11454),shellCmd(_11454),dir2logfile(_11396,_11464),appendAtom('touch ',_11464,_11472),shellCmd(_11472),dir2dbfile(_11396,_11482),appendAtom('touch ',_11482,_11490),shellCmd(_11490),dir2specfile(_11396,_11500),dynamicSpec(_11390/_11392,_11512),writePrologTermFile(_11500,_11512),writePAKCSVersion(_11396).
readPrologTermFile(_11640,_11642):-open(_11640,read,_11650),read(_11650,_11642),close(_11650).
writePrologTermFile(_11718,_11720):-open(_11718,write,_11728),writeq(_11728,_11720),put_code(_11728,46),nl(_11728),flush_output(_11728),close(_11728).
readDynamicVersion(_11828,_11830):-dir2versionfile(_11828,_11836),existsFile(_11836),!,on_exception(_11856,readPrologTermFile(_11836,_11830),_11830=0).
readDynamicVersion(_11924,1).
writeDynamicVersion(_11960,_11962):-dir2versionfile(_11960,_11968),writePrologTermFile(_11968,_11962).
readChangePids(_12026,_12028):-dir2changepidsfile(_12026,_12034),existsFile(_12034),!,on_exception(_12060,readPrologTermFile(_12034,_12028),_12028=[0]).
readChangePids(_12128,[]).
writeChangePids(_12164,_12166):-dir2changepidsfile(_12164,_12172),writePrologTermFile(_12172,_12166).
addChangePid(_12230):-currentPID(_12234),addChangePid(_12234,_12230).
addChangePid(_12284,_12286):-readChangePids(_12286,_12292),(member(_12284,_12292)->true;writeChangePids(_12286,[_12284|_12292])),!.
dynamicSpec(_12380/_12382,dynamicPredicate(_12380,_12382)).
retractDeadDynamicFacts(_12428/_12430):-length(_12438,_12430),_12450=..[_12428|_12438],_12438=[_12456,_12462|_12464],dynamicTime(_12474),call(user:_12450),_12462>0,_12474>_12462,retract(user:_12450),fail.
retractDeadDynamicFacts(_12592).
dir2logfile(_12618,_12620):-appendAtom(_12618,'/eventlog',_12620).
dir2lockfile(_12674,_12676):-appendAtom(_12674,'/LOCK',_12676).
dir2tmplockfile(_12730,_12732):-appendAtom(_12730,'/LOCK',_12732).
dir2dbfile(_12786,_12788):-appendAtom(_12786,'/database.pl',_12788).
dir2pofile(_12842,_12844):-appendAtom(_12842,'/dbpred.po',_12844).
dir2specfile(_12898,_12900):-appendAtom(_12898,'/spec',_12900).
dir2pakcsversionfile(_12954,_12956):-appendAtom(_12954,'/pakcsversion',_12956).
dir2versionfile(_13010,_13012):-appendAtom(_13010,'/version',_13012).
dir2changepidsfile(_13066,_13068):-appendAtom(_13066,'/changepids',_13068).
